"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const firestore_roles_1 = require("firestore-roles");
var Account;
(function (Account) {
    function validate(account) {
        firestore_roles_1.AccountRecord.validate(account);
    }
    Account.validate = validate;
    function fromFirebaseUserInfo(userInfo) {
        const account = {
            uid: userInfo.uid,
            displayName: userInfo.displayName,
            email: userInfo.email,
            providerId: userInfo.providerId,
            phoneNumber: null,
            photoURL: userInfo.photoURL,
        };
        firestore_roles_1.AccountRecord.validate(account);
        return account;
    }
    Account.fromFirebaseUserInfo = fromFirebaseUserInfo;
})(Account = exports.Account || (exports.Account = {}));
//# sourceMappingURL=Account.js.map