"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const firestore_roles_1 = require("firestore-roles");
const ow_1 = __importDefault(require("ow"));
const util_1 = require("./util");
var Configuration;
(function (Configuration) {
    function validate(c) {
        firestore_roles_1.FirestoreRolesConfiguration.validate(c.roles, "Configuration.roles ");
        ow_1.default(c.callbacks, "Configuration.callbacks", ow_1.default.object.is(v => util_1.ow_catch(() => AuthCallbacks.validate(v))));
    }
    Configuration.validate = validate;
    // tslint:disable no-shadowed-variable
    let AuthCallbacks;
    (function (AuthCallbacks) {
        function validate(ac) {
            ow_1.default(ac.onAuthenticated, "Callbacks.onAuthenticated", ow_1.default.function);
            ow_1.default(ac.onError, "Callbacks.onError", ow_1.default.function);
            ow_1.default(ac.onNotAuthenticated, "Callbacks.onNotAuthenticated", ow_1.default.function);
        }
        AuthCallbacks.validate = validate;
    })(AuthCallbacks = Configuration.AuthCallbacks || (Configuration.AuthCallbacks = {}));
})(Configuration = exports.Configuration || (exports.Configuration = {}));
//# sourceMappingURL=Configuration.js.map