"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class AuthAdapter {
    constructor(auth) {
        this.auth = auth;
    }
    initialize(callbacks) {
        this.auth.onAuthStateChanged((user) => {
            if (user) {
                callbacks.onAuthenticated(user);
            }
            else {
                callbacks.onNotAuthenticated();
            }
        }, (error) => {
            callbacks.onError(error.message);
        });
    }
    signOut() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.auth.signOut();
        });
    }
}
exports.AuthAdapter = AuthAdapter;
//# sourceMappingURL=AuthAdapter.js.map