import { AccountRecord } from "firestore-roles";
import { Account } from "../Account";
import { Configuration } from "../Configuration";
export declare class RolesAdapter {
    private firestoreRoles;
    private availableRoles;
    constructor(config: Configuration, firestore: firebase.firestore.Firestore);
    getAvailableRoles(): string[];
    isAvailableRole(role: string): boolean;
    userExists(uid: string): Promise<boolean>;
    registerUser(account: Account): Promise<void>;
    hasRole(uid: string, role: string): Promise<boolean>;
    isRoleRequestedByUser(uid: string, role: string): Promise<boolean>;
    getUidsInRole(role: string): Promise<string[]>;
    getUidsRequestingRole(role: string): Promise<string[]>;
    getAccountRecord(uid: string): Promise<AccountRecord>;
    enableRole(uid: string, role: string): Promise<void>;
    disableRole(uid: string, role: string): Promise<void>;
    requestRole(uid: string, role: string): Promise<void>;
    removeRoleRequest(uid: string, role: string): Promise<void>;
}
