"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable member-ordering
const firestore_roles_1 = __importDefault(require("firestore-roles"));
const _ = __importStar(require("lodash"));
class RolesAdapter {
    constructor(config, firestore) {
        this.firestoreRoles = new firestore_roles_1.default(config.roles, firestore);
        this.availableRoles = _.keys(config.roles.roles);
    }
    getAvailableRoles() {
        return this.availableRoles;
    }
    isAvailableRole(role) {
        return this.availableRoles.indexOf(role) >= 0;
    }
    userExists(uid) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.userExists(uid);
        });
    }
    registerUser(account) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.registerUser(account);
        });
    }
    hasRole(uid, role) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.hasRole(uid, role);
        });
    }
    isRoleRequestedByUser(uid, role) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.isRoleRequestedByUser(uid, role);
        });
    }
    getUidsInRole(role) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.getUidsInRole(role);
        });
    }
    getUidsRequestingRole(role) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.getUidsRequestingRole(role);
        });
    }
    getAccountRecord(uid) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.getAccountRecord(uid);
        });
    }
    enableRole(uid, role) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.enableRole(uid, role);
        });
    }
    disableRole(uid, role) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.disableRole(uid, role);
        });
    }
    requestRole(uid, role) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.requestRole(uid, role);
        });
    }
    removeRoleRequest(uid, role) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firestoreRoles.removeRoleRequest(uid, role);
        });
    }
}
exports.RolesAdapter = RolesAdapter;
//# sourceMappingURL=RolesAdapter.js.map