import { Commit, Mutation as VuexMutation } from "vuex";
import { Account } from "../Account";
import { RolesAuthModule as Me } from "./RolesAuthModule";
declare type MutationFn = VuexMutation<Me.State>;
export declare namespace Mutations {
    namespace SetAccount {
        const name: string;
        type Payload = Account;
        type Declaration = MutationFn & ((state: Me.State, payload: Payload) => void);
        function commit(commitFn: Commit, payload: Payload): void;
    }
    namespace ResetUser {
        const name: string;
        type Declaration = MutationFn & ((state: Me.State) => void);
        function commit(commitFn: Commit): void;
    }
    namespace SetState {
        const name: string;
        interface Payload {
            state: Me.AuthState;
        }
        type Declaration = MutationFn & ((state: Me.State, payload: Payload) => void);
        function commit(commitFn: Commit, payload: Payload): void;
    }
    namespace SetRole {
        const name: string;
        interface Payload {
            role: string;
            hasRole: boolean;
        }
        type Declaration = MutationFn & ((state: Me.State, payload: Payload) => void);
        function commit(commitFn: Commit, payload: Payload): void;
    }
    namespace SetRoleRequest {
        const name: string;
        interface Payload {
            role: string;
            isRequestingRole: boolean;
        }
        type Declaration = MutationFn & ((state: Me.State, payload: Payload) => void);
        function commit(commitFn: Commit, payload: Payload): void;
    }
}
export {};
