import { CombinedVueInstance } from "vue/types/vue";
import { Action as VuexAction, ActionContext as VuexActionContext, Dispatch } from "vuex";
import { Account } from "../Account";
declare type ActionFn = VuexAction<RolesAuthModule.State, RolesAuthModule.State>;
declare type ActionContext = VuexActionContext<RolesAuthModule.State, RolesAuthModule.State>;
export declare namespace RolesAuthModule {
    const modulePathName = "roles_auth";
    function localName(name: string): string;
    /**
     *
     * State
     */
    interface State {
        state: AuthState;
        account?: Account;
        roles: {
            [roleName: string]: boolean;
        };
        roleRequests: {
            [roleName: string]: boolean;
        };
    }
    namespace State {
        function validate(state: State): void;
    }
    /**
     *
     * Actions
     */
    namespace Actions {
        namespace Initialize {
            const name: string;
            type Declaration = ActionFn & ((c: ActionContext) => void);
            interface Implementator {
                getAction(): Declaration;
            }
            function dispatch(dispatchFn: Dispatch): Promise<any>;
        }
        namespace Logout {
            const name: string;
            type Declaration = ActionFn & ((c: ActionContext) => void);
            interface Implementator {
                getAction(): Declaration;
            }
            function dispatch(dispatchFn: Dispatch): Promise<any>;
        }
        namespace CheckRole {
            const name: string;
            type Payload = string;
            type Declaration = ActionFn & ((c: ActionContext, role: Payload) => void);
            interface Implementator {
                getAction(): Declaration;
            }
            function dispatch(dispatchFn: Dispatch, role: Payload): Promise<any>;
        }
    }
    /**
     * State tye guard
     */
    function stateOf(vueInstance: CombinedVueInstance<any, any, any, any, any>): State;
    /**
     *
     * Getters
     */
    class Getters {
        static isAuthenticated: string;
        static isNotAuthenticated: string;
    }
    /**
     *
     * AuthState
     */
    enum AuthState {
        LOADING = "LOADING",
        AUTHENTICATED = "AUTHENTICATED",
        NOTAUTHENTICATED = "NOTAUTHENTICATED"
    }
}
export {};
