"use strict";
// tslint:disable:max-classes-per-file
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ow_1 = __importDefault(require("ow"));
const Account_1 = require("../Account");
const util_1 = require("../util");
var RolesAuthModule;
(function (RolesAuthModule) {
    RolesAuthModule.modulePathName = "roles_auth";
    function localName(name) {
        return RolesAuthModule.modulePathName + "_" + name;
    }
    RolesAuthModule.localName = localName;
    let State;
    (function (State) {
        function validate(state) {
            ow_1.default(state.state, "state.state", ow_1.default.string.oneOf([AuthState.LOADING, AuthState.AUTHENTICATED, AuthState.NOTAUTHENTICATED]));
            ow_1.default(state.account, "state.account", ow_1.default.any(ow_1.default.undefined, ow_1.default.object.is(v => util_1.ow_catch(() => Account_1.Account.validate(v)))));
            ow_1.default(state.roles, "state.roles", ow_1.default.object.valuesOfType(ow_1.default.boolean));
            ow_1.default(state.roleRequests, "state.roleRequests", ow_1.default.object.valuesOfType(ow_1.default.boolean));
        }
        State.validate = validate;
    })(State = RolesAuthModule.State || (RolesAuthModule.State = {}));
    /**
     *
     * Actions
     */
    let Actions;
    (function (Actions) {
        let Initialize;
        (function (Initialize) {
            Initialize.name = localName("initialize");
            function dispatch(dispatchFn) {
                return dispatchFn(Initialize.name);
            }
            Initialize.dispatch = dispatch;
        })(Initialize = Actions.Initialize || (Actions.Initialize = {}));
        let Logout;
        (function (Logout) {
            Logout.name = localName("logout");
            function dispatch(dispatchFn) {
                return dispatchFn(Logout.name);
            }
            Logout.dispatch = dispatch;
        })(Logout = Actions.Logout || (Actions.Logout = {}));
        let CheckRole;
        (function (CheckRole) {
            CheckRole.name = localName("checkRole");
            function dispatch(dispatchFn, role) {
                return dispatchFn(CheckRole.name, role);
            }
            CheckRole.dispatch = dispatch;
        })(CheckRole = Actions.CheckRole || (Actions.CheckRole = {}));
    })(Actions = RolesAuthModule.Actions || (RolesAuthModule.Actions = {}));
    /**
     * State tye guard
     */
    function stateOf(vueInstance) {
        return vueInstance.$store.state[RolesAuthModule.modulePathName];
    }
    RolesAuthModule.stateOf = stateOf;
    /**
     *
     * Getters
     */
    class Getters {
    }
    Getters.isAuthenticated = localName("isAuthenticated");
    Getters.isNotAuthenticated = localName("isNotAuthenticated");
    RolesAuthModule.Getters = Getters;
    /**
     *
     * AuthState
     */
    let AuthState;
    (function (AuthState) {
        AuthState["LOADING"] = "LOADING";
        AuthState["AUTHENTICATED"] = "AUTHENTICATED";
        AuthState["NOTAUTHENTICATED"] = "NOTAUTHENTICATED";
    })(AuthState = RolesAuthModule.AuthState || (RolesAuthModule.AuthState = {}));
})(RolesAuthModule = exports.RolesAuthModule || (exports.RolesAuthModule = {}));
//# sourceMappingURL=RolesAuthModule.js.map